uniform lowp sampler2D u_texture;
uniform mediump vec4 u_color;

varying mediump vec2 v_texCoord;
varying lowp float v_fogFactor;
varying lowp vec4 v_fogColor;

void main()
{
	// 2Dテクスチャの色を反映
	// 頂点カラーを反映
	// 現在の描画色にフォグ係数を反映
	// 現在の色に視点からの距離によるフォグの色を反映
	gl_FragColor = ( texture2D( u_texture, v_texCoord ) * u_color * v_fogFactor ) + v_fogColor;
}
