attribute highp vec4 a_vertex;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_ModelViewProj;
uniform highp mat4 u_ModelView;

uniform highp float u_fogParam1;
uniform highp float u_fogParam2;
uniform lowp vec4 u_fogColor;

varying mediump vec2 v_texCoord;
varying lowp float v_fogFactor;
varying lowp vec4 v_fogColor;

void main()
{
	vec4 a_fogColor;

 	// 頂点を視点空間に座標変換する
	highp float z = (u_ModelView * a_vertex).z;

	// 出力位置を座標変換する
    gl_Position = u_ModelViewProj * a_vertex;
		
	// テクスチャ座標をそのまま渡す
	v_texCoord = a_texCoord;
		
	// フォグ係数を[0,1]で作成
	v_fogFactor = clamp( u_fogParam1 + u_fogParam2 * z, 0.0, 1.0 );
	
	// フォグ係数とフォグの色から視点からの距離による色を作成
	a_fogColor = u_fogColor * ( 1.0 - v_fogFactor );
	v_fogColor = vec4( a_fogColor.xyz, 0.0 );
}
