attribute highp vec4 a_vertex;
attribute mediump vec3 a_normal;
//attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_ModelViewProj;
uniform highp vec3 u_eyePosition;

uniform lowp vec3 u_lightAmbient;
uniform lowp vec3 u_lightDiffuse;
uniform lowp vec3 u_lightSpecular;
uniform highp vec3 u_lightPosition;
uniform mediump float u_lightConstantAttenuation;
uniform mediump float u_lightLinearAttenuation;
uniform mediump float u_lightQuadraticAttenuation;

uniform lowp vec3 u_materialAmbient;
uniform lowp vec3 u_materialDiffuse;
uniform lowp vec3 u_materialSpecular;
uniform lowp vec3 u_materialEmission;
uniform mediump float u_materialShininess;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
//varying lowp vec4 v_diffuse;



uniform highp mat4 u_ModelView;
uniform highp mat4 u_invModelView;




void main()
{
/*	vec4 position = u_ModelView * a_vertex;
	
	gl_Position = u_ModelViewProj * a_vertex;
	
//	lowp vec3 N = normalize( u_invModelView * a_normal );
	lowp vec3 N = normalize( (u_invModelView * vec4(a_normal,1.0)).xyz );
	
	//　Ambient Color
	lowp vec3 ambient = u_materialAmbient * u_lightAmbient;
	
	//　Diffuse Color
	// 光源ベクトル
//	vec3 L = u_lightPosition - a_vertex.xyz;
	vec3 L = u_lightPosition - position.xyz;
	// 光源までの距離
	float dis = length(L);
	// ベクトルの正規化
	L = normalize(L);
	// 減衰係数
	float attenuation = 1.0 / (u_lightConstantAttenuation +
	                           u_lightLinearAttenuation * dis +
	                           u_lightQuadraticAttenuation * dis * dis);
//	float attenuation = 0.1;
							   
	mediump float diffuseLight = max(dot(L, N), 0.0);
	mediump vec3 diffuse = u_materialDiffuse * u_lightDiffuse * (diffuseLight * attenuation);
	
	// Specular Color
	lowp vec3 V = normalize(u_eyePosition - a_vertex.xyz);
//	lowp vec3 V = normalize(u_eyePosition - position.xyz);
	lowp vec3 R = reflect( -V, N );	//　反射ベクトル -V + 2.0 * dot(N, V) * N;
	mediump float specularLight = pow(max(dot(L, R), 0.0), u_materialShininess);
	mediump vec3 specular = u_materialSpecular * u_lightSpecular * (specularLight * attenuation);

	v_color = a_color;
	v_diffuse = vec4(ambient + diffuse + specular, 1.0);
	v_texCoord = a_texCoord;
*/

#if 0
	lowp vec3 N = a_normal;
	
	vec3 L = u_lightPosition - a_vertex.xyz;

/*	vec4 position = u_ModelView * a_vertex;
	
//	lowp vec3 N = normalize( (u_invModelView * vec4(a_normal, 0.0)).xyz );
	lowp vec3 N = (u_invModelView * vec4(a_normal, 0.0)).xyz;
	
	vec3 L = u_lightPosition - position.xyz;
*/
	
	// 光源までの距離
	float dis = length(L);
	// ベクトルの正規化
	L = normalize(L);
	// 減衰係数
//	float attenuation = 1.0 / (u_lightConstantAttenuation +
//	                           u_lightLinearAttenuation * dis +
//	                           u_lightQuadraticAttenuation * dis * dis);
	const float attenuation = 1.0;
		
	//　Ambient Color
//	lowp vec3 ambient = u_materialAmbient * u_lightAmbient;
	lowp vec3 color = u_materialAmbient * u_lightAmbient;
	
	mediump float diffuseLight = max(dot(L, N), 0.0);
//	mediump vec3 diffuse = u_materialDiffuse * u_lightDiffuse * (diffuseLight * attenuation);
	color += u_materialDiffuse * u_lightDiffuse * (diffuseLight * attenuation);

	lowp vec3 h_vec = normalize( L + vec3(0.0,0.0,1.0) );
//	vec3 view = normalize( position.xyz );
//	vec3 h_vec = normalize( L - view );
//	float ndoth = dot( N, h_vec );
	
//	mediump float specularLight = pow(max(ndoth, 0.0), u_materialShininess);
	mediump float specularLight = pow(max(dot( N, h_vec ), 0.0), u_materialShininess);
//	mediump vec3 specular = u_materialSpecular * u_lightSpecular * (specularLight * attenuation);
	color += u_materialSpecular * u_lightSpecular * (specularLight * attenuation);
	
	gl_Position = u_ModelViewProj * a_vertex;
	v_color = a_color * vec4(color, 1.0);
//	v_diffuse = vec4(ambient + diffuse + specular, 1.0);
//	v_diffuse = vec4(color, 1.0);
	v_texCoord = a_texCoord;
#endif

#if 0
	vec3 L = normalize( u_lightPosition - a_vertex.xyz );
			
	//　Ambient Color
	lowp vec3 color = u_materialAmbient * u_lightAmbient;
	
	mediump float diffuseLight = max(dot(L, a_normal), 0.0);
	color += u_materialDiffuse * u_lightDiffuse * diffuseLight;

//	lowp vec3 h_vec = normalize( L + vec3(0.0,0.0,1.0) );	
	lowp vec3 h_vec = normalize( L + (u_eyePosition - a_vertex.xyz) );	
	mediump float specularLight = pow(max(dot(a_normal, h_vec), 0.0), u_materialShininess);
	color += u_materialSpecular * u_lightSpecular * specularLight;
	
	gl_Position = u_ModelViewProj * a_vertex;
	v_color = a_color * vec4(color, 1.0);
	v_texCoord = a_texCoord;	
#endif

#if 1
//	vec3 LightDirection = normalize( vec3( 1.0, -1.0, 1.0 ) );
//	vec3 RimColor = vec3( 0.3254, 0.333, 0.310 );
	const vec3 RimColor = vec3( -0.8, -0.8, -0.8 );
//	vec3 RimColor = vec3( 0.0, 0.0, 0.0 );
//	float RimIntensity = 1.0;

	vec3 N = normalize( a_normal );
	
	vec3 E = normalize( u_eyePosition - a_vertex.xyz );
	
//	vec3 L = normalize( u_lightPosition - a_vertex.xyz );
	vec3 L = normalize( -u_lightPosition );
//	vec3 L = normalize( -LightDirection );
			
/*	//　Ambient Color
	lowp vec3 color = u_materialAmbient * u_lightAmbient;
	
	mediump float diffuseLight = 1.0 - max(dot(L, a_normal), 0.0);
	color = u_materialDiffuse * u_lightDiffuse * diffuseLight;

	lowp vec3 h_vec = normalize( L + vec3(0.0,0.0,1.0) );	
	mediump float specularLight = pow(max(dot(a_normal, h_vec), 0.0), u_materialShininess);
	color += u_materialSpecular * u_lightSpecular * specularLight;
	
	gl_Position = u_ModelViewProj * a_vertex;
	v_color = a_color * vec4(color, 1.0);
	v_texCoord = a_texCoord;	
*/

//	lowp vec3 Ambient = u_materialAmbient * u_lightAmbient * 0.3;
//	lowp vec3 Diffuse = u_materialDiffuse * u_lightDiffuse * max( dot( N, L ), 0.0 );
//	lowp vec3 Rim = u_materialSpecular * u_lightSpecular * 0.5 * pow( 1.0 - dot( N, E ), /*u_materialShininess*/2.0 );
///	lowp vec3 Ambient = a_color.rgb * 0.3;
///	lowp vec3 Diffuse = a_color.rgb * max( dot( N, L ), 0.0 ) * 1.0;
//	lowp vec3 Diffuse = a_color.rgb * -dot( N, L );
///	lowp vec3 Rim = RimColor * 0.5 * pow( 1.0 - dot( N, E ), /*u_materialShininess*/2.0 );
////	lowp vec3 Ambient = a_color.rgb * 0.3;
////	lowp vec3 Diffuse = a_color.rgb * max( dot( N, L ), 0.0 ) * 1.0;
//	lowp vec3 Diffuse = a_color.rgb * -dot( N, L );
////	lowp vec3 Rim = RimColor * 0.5 * pow( 1.0 - dot( N, E ), /*u_materialShininess*/2.0 );
	
	// ハーフベクトル
	vec3 H = normalize( L + E );
	
	vec3 Ambient = u_materialAmbient * u_lightAmbient;
	
	vec3 Diffuse = u_materialDiffuse * u_lightDiffuse * max( dot( N, L ), 0.0 );
	
	vec3 Specular = u_materialSpecular * u_lightSpecular * pow(max(dot(N, H), 0.0), u_materialShininess);
	
//	vec3 R = reflect( -E, N );	//　反射ベクトル -V + 2.0 * dot(N, V) * N;
//	vec3 Specular = u_materialSpecular * u_lightSpecular * pow(max(dot(L, R), 0.0), u_materialShininess);

//	float light_rim = max(dot(N, -L), 0.0);
	vec3 Rim = RimColor * pow( 1.0 - dot( N, E ), 0.5 );// * RimIntensity;


	gl_Position = u_ModelViewProj * a_vertex;
//	v_color = a_color * vec4( u_materialEmission + Ambient + Diffuse + Specular + Rim, 1.0 );
	v_color = vec4( u_materialEmission + Ambient + Diffuse + Specular + Rim, 1.0 );
//	v_color = a_color * vec4( Ambient + Diffuse + Specular + Rim, 1.0 );
//	v_color = a_color * vec4( Rim, 1.0 );
	v_texCoord = a_texCoord;
#endif

}
