uniform lowp sampler2D u_texture;
uniform lowp sampler2D u_texture1;
uniform mediump vec4 u_color;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp vec4 v_diffuse;

//varying lowp vec4 v_vcolor;
varying lowp vec3 v_Ambient;
varying lowp vec3 v_Diffuse;
varying lowp vec3 v_Specular;

varying lowp vec3 v_Light;
varying lowp vec3 v_Eye;

//varying highp vec4 v_vertex;
//varying mediump vec3 v_normal;

//uniform lowp vec3 u_lightAmbient;
//uniform lowp vec3 u_lightDiffuse;
//uniform lowp vec3 u_lightSpecular;
//uniform highp vec3 u_lightPosition;
//uniform mediump float u_lightConstantAttenuation;
//uniform mediump float u_lightLinearAttenuation;
//uniform mediump float u_lightQuadraticAttenuation;
//
//uniform lowp vec3 u_materialAmbient;
//uniform lowp vec3 u_materialDiffuse;
//uniform lowp vec3 u_materialSpecular;
//uniform lowp vec3 u_materialEmission;
uniform mediump float u_materialShininess;


void main()
{
#if 0
	highp vec3 normalVec = 2.0 * texture2D( u_texture1, v_texCoord ).xyz - 1.0;
	
	highp float bright = dot( v_Light.xyz, normalVec );
	bright = max( 0.0, bright );
	
	gl_FragColor = v_vertex_color * (v_color + v_diffuse) * bright * texture2D( u_texture, v_texCoord );
//	gl_FragColor = (v_color * texture2D( u_texture, v_texCoord ) * bright );
#endif

#if 0
	highp float s = texture2D(u_texture1, v_texCoord).a;
	
	highp vec3 normalVec = 2.0 * texture2D(u_texture1, v_texCoord).xyz - 1.0;
	highp float bright = dot( v_Light, normalVec );
	bright = max( 0.0, bright );

//	gl_FragColor = v_color * texture2D( u_texture, v_texCoord ) * bright;
	gl_FragColor = v_vcolor * vec4(v_Ambient + (v_Diffuse + v_Specular * s) * bright, 1.0) * texture2D( u_texture, v_texCoord );
#endif

#if 1
	// Specular Map
	lowp float S = texture2D(u_texture1, v_texCoord).a;
	
	// Normal Map
	lowp vec3 N = 2.0 * texture2D(u_texture1, v_texCoord).xyz - 1.0;
	
	// light
	lowp vec3 L = normalize(v_Light);
	
	// Eye
	lowp vec3 E = normalize(v_Eye);
	
	//　Diffuse Color
	lowp float diffuseLight = max(dot(L, N), 0.0);
	lowp vec3 diffuse = v_Diffuse * diffuseLight;
	
	// Specular Color
	lowp vec3 R = reflect(-E, N);
	lowp float specularLight = pow(max(dot(L, R), 0.0), u_materialShininess);
//	lowp vec3 H = normalize(L + E);
//	lowp float specularLight = pow(max(dot(N, H), 0.0), u_materialShininess);
	lowp vec3 specular = v_Specular * specularLight * S;

	gl_FragColor = u_color * v_color * vec4(v_Ambient + diffuse + specular, 1.0) * texture2D( u_texture, v_texCoord );
#endif

#if 0
	highp vec3 N = 2.0 * texture2D(u_texture1, v_texCoord).xyz - 1.0;
	highp vec3 L = normalize(v_Light);
	highp vec3 R = reflect(-normalize(v_Eye), N);
	highp float amb = 0.1;

	gl_FragColor = v_color * texture2D( u_texture, v_texCoord ) * max(0.0, dot(N, L) + amb) + 0.3 * pow(max(0.0, dot(R, L)), 8.0);
#endif

#if 0
	highp vec3 N = 2.0 * texture2D(u_texture1, v_texCoord).xyz - 1.0;
	highp vec3 H = normalize( v_Light + v_Eye );
	highp float S = pow( max( 0.0, dot( N, H ) ), 10.0 ) * 0.4;
	
	gl_FragColor = v_color * texture2D( u_texture, v_texCoord ) * max( 0.0, dot( N, v_Light ) ) + S;
#endif

#if 0
	highp vec3 N = 2.0 * texture2D(u_texture1, v_texCoord).xyz - 1.0;
	highp vec3 E = normalize(v_Eye);
	highp vec3 R = -E + 2.0 * dot(E, N) * N;
	highp vec3 L = normalize(v_Light);
	
	highp float RL = max(dot(R,L), 0.0);
	highp float NL = max(dot(N,L), 0.0);
	
	highp vec4 amb = vec4( 0.1, 0.05,  0.04, 1.0 );
	highp vec4 dif = vec4( 1.0, 0.6, 0.4, 1.0 );
	highp vec4 spe = vec4( 2.0, 1.8, 1.2, 1.0 );
	
	
	gl_FragColor = v_color *NL*pow(RL, 64.0)* texture2D( u_texture, v_texCoord );
#endif
}
