uniform lowp sampler2D u_texture;
uniform lowp sampler2D u_texture1;
uniform mediump vec4 u_color;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp vec4 v_diffuse;

varying lowp vec3 v_Ambient;
varying lowp vec3 v_Diffuse;
varying lowp vec3 v_Specular;

varying lowp vec3 v_Light;
varying lowp vec3 v_Eye;

uniform mediump float u_materialShininess;

varying lowp float v_fogFactor;
varying lowp vec4 v_fogColor;

void main()
{
	// Specular Map
	lowp float S = texture2D(u_texture1, v_texCoord).a;
	
	// Normal Map
	lowp vec3 N = 2.0 * texture2D(u_texture1, v_texCoord).xyz - 1.0;
	
	// light
	lowp vec3 L = normalize(v_Light);
	
	// Eye
	lowp vec3 E = normalize(v_Eye);
	
	//　Diffuse Color
	lowp float diffuseLight = max(dot(L, N), 0.0);
	lowp vec3 diffuse = v_Diffuse * diffuseLight;
	
	// Specular Color
	lowp vec3 R = reflect(-E, N);
	lowp float specularLight = pow(max(dot(L, R), 0.0), u_materialShininess);
//	lowp vec3 H = normalize(L + E);
//	lowp float specularLight = pow(max(dot(N, H), 0.0), u_materialShininess);
	lowp vec3 specular = v_Specular * specularLight * S;

	gl_FragColor = ((u_color * v_color * vec4(v_Ambient + diffuse + specular, 1.0) * texture2D( u_texture, v_texCoord )) * v_fogFactor) + v_fogColor;
}
